# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..258\n"; }
END {print "not ok 1\n" unless $loaded;}
use Crypt::Memfrob 'memfrob';
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

use strict;

my $ok_counter = 2;
sub ok {
    shift or print "not ";
    print "ok ", $ok_counter ++, "\n";
}

my @correct_table = (0x2A, 0x2B, 0x28, 0x29, 0x2E, 0x2F, 0x2C, 0x2D,
		     0x22, 0x23, 0x20, 0x21, 0x26, 0x27, 0x24, 0x25,
		     0x3A, 0x3B, 0x38, 0x39, 0x3E, 0x3F, 0x3C, 0x3D,
		     0x32, 0x33, 0x30, 0x31, 0x36, 0x37, 0x34, 0x35,
		     0x0A, 0x0B, 0x08, 0x09, 0x0E, 0x0F, 0x0C, 0x0D,
		     0x02, 0x03, 0x00, 0x01, 0x06, 0x07, 0x04, 0x05,
		     0x1A, 0x1B, 0x18, 0x19, 0x1E, 0x1F, 0x1C, 0x1D,
		     0x12, 0x13, 0x10, 0x11, 0x16, 0x17, 0x14, 0x15,
		     0x6A, 0x6B, 0x68, 0x69, 0x6E, 0x6F, 0x6C, 0x6D,
		     0x62, 0x63, 0x60, 0x61, 0x66, 0x67, 0x64, 0x65,
		     0x7A, 0x7B, 0x78, 0x79, 0x7E, 0x7F, 0x7C, 0x7D,
		     0x72, 0x73, 0x70, 0x71, 0x76, 0x77, 0x74, 0x75,
		     0x4A, 0x4B, 0x48, 0x49, 0x4E, 0x4F, 0x4C, 0x4D,
		     0x42, 0x43, 0x40, 0x41, 0x46, 0x47, 0x44, 0x45,
		     0x5A, 0x5B, 0x58, 0x59, 0x5E, 0x5F, 0x5C, 0x5D,
		     0x52, 0x53, 0x50, 0x51, 0x56, 0x57, 0x54, 0x55,
		     0xAA, 0xAB, 0xA8, 0xA9, 0xAE, 0xAF, 0xAC, 0xAD,
		     0xA2, 0xA3, 0xA0, 0xA1, 0xA6, 0xA7, 0xA4, 0xA5,
		     0xBA, 0xBB, 0xB8, 0xB9, 0xBE, 0xBF, 0xBC, 0xBD,
		     0xB2, 0xB3, 0xB0, 0xB1, 0xB6, 0xB7, 0xB4, 0xB5,
		     0x8A, 0x8B, 0x88, 0x89, 0x8E, 0x8F, 0x8C, 0x8D,
		     0x82, 0x83, 0x80, 0x81, 0x86, 0x87, 0x84, 0x85,
		     0x9A, 0x9B, 0x98, 0x99, 0x9E, 0x9F, 0x9C, 0x9D,
		     0x92, 0x93, 0x90, 0x91, 0x96, 0x97, 0x94, 0x95,
		     0xEA, 0xEB, 0xE8, 0xE9, 0xEE, 0xEF, 0xEC, 0xED,
		     0xE2, 0xE3, 0xE0, 0xE1, 0xE6, 0xE7, 0xE4, 0xE5,
		     0xFA, 0xFB, 0xF8, 0xF9, 0xFE, 0xFF, 0xFC, 0xFD,
		     0xF2, 0xF3, 0xF0, 0xF1, 0xF6, 0xF7, 0xF4, 0xF5,
		     0xCA, 0xCB, 0xC8, 0xC9, 0xCE, 0xCF, 0xCC, 0xCD,
		     0xC2, 0xC3, 0xC0, 0xC1, 0xC6, 0xC7, 0xC4, 0xC5,
		     0xDA, 0xDB, 0xD8, 0xD9, 0xDE, 0xDF, 0xDC, 0xDD,
		     0xD2, 0xD3, 0xD0, 0xD1, 0xD6, 0xD7, 0xD4, 0xD5);

for (my $i = 0x00; $i < 0x100; $i ++) {
    ok(memfrob(chr $i) eq chr($correct_table[$i]));
}

print "#\n";

ok(memfrob(join "", map { chr $_ } (0x00 .. 0xFF))
   eq join "", map { chr $_ } (@correct_table));
